#ifndef __MAP_H__
#define __MAP_H__

#include "cywin.h"

#define NEW(x) (x*)malloc(sizeof(x))

typedef struct _Map
{
	int m_w;
	int m_h;
	char* m_map;
} Map;

typedef struct _Map MAP;
typedef struct _Map* PMAP;

PMAP Map_ctor(PMAP pMap,int width,int height);
PMAP Map_ctor_Ex(PMAP pMap,struct FileInput* pInput);
PMAP Map_new(int width,int height);
PMAP Map_new_Ex(struct Input* pInput);

void Map_dtor(PMAP pMap,int memflag);
void Map_del(PMAP pMap);

void Map_set_square(PMAP pMap,int x,int y,char val);

char Map_get_square(PMAP pMap,int x,int y);
int Map_get_w(PMAP pMap);
int Map_get_h(PMAP pMap);
long Map_get_size(PMAP pMap);

void Map_clear(PMAP pMap,char val);

void Map_write(PMAP pMap,struct Output* pOutput);

#endif
